#!/usr/bin/perl
# p^: page(y[W)
require './config.pl';
require './cgicommon.pl';
&wdecode;

print "Content-type: text/html; charset=$encoding\n\n";
print <<"_HTML_";
<html xmlns="http://www.w3.org/1999/xhtml" lang="ja" xml:lang="ja">
<head>
  <meta http-equiv="Content-type" content="text/html; charset=$encoding" />
  <meta http-equiv="Cache-Control" content="no-cache" />
  <meta http-equiv="Pragma" content="no-cache" />
  <meta http-equiv="Content-Script-Type" content="text/javascript" />
  <title>$top_title</title>
  <link rel="stylesheet" href="$top_css" type="text/css" />
  <script type="text/javascript">
    if (window != top) top.location.href = location.href;
  </script>
</head>
<body>
  <h1 align="center">$top_title</h1>
  <div class="desc">
_HTML_

open(DESC, "$desc_file");
while(<DESC>) { print $_; };
close(DESC);

print <<"_HTML_";
  </div>
  <div align="center" class="form">
    <form method="POST" action="./$challenge_cgi">
      <input type="text" name="word" size="40" />
      <input type="submit" value='@ꔯ!' />
    </form>
    <p><a href="http://kids.goo.ne.jp/"><img src="http://kids.goo.ne.jp/help/link_img/1_20040.gif" width="200" height="40" border="0" alt="kids.goo"></a></p>
  </div>
  <hr />
_HTML_
    &load_log;
    &show_log;
print <<"_HTML_";
  <hr />
  <div align="right" class="foot">
    presented by <a href="$back_link"><b>$back_title</b></a>
  </div>
</body>
</html>
_HTML_

exit;

##################################################
#@log_lines ɕ\ɕKvȃOǂݍ.
#$log_line_count ɃÕg[^sZbg.
sub load_log {
    my($m_page,$m_start,$m_end);
    open(LOG,"$log_file");
    $m_page = int($FORM{'page'});
    $log_line_count = 0;
    $m_start = $m_page * $max_page;
    $m_end = $m_start + $max_page;
    while(<LOG>) {
	if($m_start<=$log_line_count && $log_line_count<$m_end) {
	    chop;
	    push(@log_lines, $_);
	}
	$log_line_count++;
    }
    close(LOG);
}#load_log END
##################################################
# @log_lines ̃O𐮌`ĕ\
sub show_log {
    my($m_page,$m_line,$m_word,$m_comment);
    $m_page = int($FORM{'page'});
    print "<table align=\"center\" width=\"80%\">\n";
    print "<caption>҂̋</caption>\n";
    print "<tr><th class=\"head\">t[Y</th>";
    print "<th class=\"head\">Rg</th></tr>\n";
    foreach(@log_lines) {
	($m_word,$m_comment) = split("\t", $_);
	$m_comment =~ s/<br>/<br \/>/g;
	print "<tr><th valign=\"top\" width=\"25%\">$m_word</th>";
	print "<td>$m_comment</td></tr>\n";
    }
    print "</table>\n";
    print "<hr width=\"50%\"/>";
    &show_page_links;
}#show_log END
##################################################
#y[WN\
sub show_page_links {
    my($m_page,$m_last,$i,$x);
    $m_page = int($FORM{'page'});
    $m_last = int($log_line_count / $max_page);
    $m_last++ if($log_line_count % $max_page > 0);
    print "<div align=\"center\" class=\"links\">";
    print "<span class=\"title\">ߋO: </span>";
    $x = $m_page - 1;
    print " <a href=\"$top_cgi?page=$x\"></a>: " if($x >= 0);
    for($i=0;$i<$m_last;$i++) {
	print " " if($i>0);
	if($i==$m_page) {
	    print "<b>$i</b>";
	} else {
	    print "<a href=\"$top_cgi?page=$i\">$i</a>";
	}
    }
    $x = $m_page + 1;
    print " :<a href=\"$top_cgi?page=$x\"></a>" if($x < $m_last);
    print "</div>\n";
}
